
//** Necessary JAVA Classes
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.lang.*;

public class 
VrmlProducer 
{
  public String
  produceElevationGrid(int pixels[], int w, int h)
  {
     StringBuffer color= new StringBuffer(" [ ");
     StringBuffer height= new StringBuffer(" [ ");
     int max = (pixels[0]>>16) & 0x000000ff;
     int i,j, r, g, b, m;

     for(i=0;i<w*h;i++) max = Math.max(max,(pixels[i]>>16) & 0x000000ff);
     System.out.println("Max is "+max);

     for(i=0;i<h;i++,System.out.println(" i: "+i))
       for(j=0;j<w;j++)
       {
          m = i*w+j;
          r = (pixels[m]>>16) &  0x000000ff; 
          g = (pixels[m]>>8) &  0x000000ff; 
          b = (pixels[m]) &  0x000000ff; 
          //height = height + " " + (10f*r/max) ;
          height.append(" " + (10f*r/max)) ;
          //color  = color + " " +(1f*r/255f)+" "+(1f*g/255f)+" "+(1f*b/255f);
          color.append(" " +(1f*r/255f)+" "+(1f*g/255f)+" "+(1f*b/255f));

          if((m%30)==0) { height.append("\n"); color.append("\n"); }

       }// end of for of for

     StringBuffer ColorNode = new StringBuffer(" Color { ");
     ColorNode.append(" color "+color.toString()+" ]  } ");
     //StringBuffer ret = new StringBuffer("#VRML V2.0 utf8 \n ");
     StringBuffer ret = new StringBuffer(" Transform { children Shape { \n ");
     //ret.append(" Transform { children Shape { \n ");
     ret.append(" appearance Appearance  { \n ");
     ret.append(" material Material {} } \n ");
     ret.append(" geometry ElevationGrid { \n ");

     ret.append(" ccw  TRUE ");
     ret.append(" colorPerVertex   TRUE ");
     ret.append(" creaseAngle   0 ");
     ret.append(" normalPerVertex   TRUE ");
     ret.append(" solid   TRUE ");
     ret.append(" xDimension   "+w+" ");
     ret.append(" xSpacing   1.0 ");
     ret.append(" zDimension   "+h+" ");
     ret.append(" zSpacing   1.0 ");

     //StringBuffer ret = new StringBuffer(" ElevationGrid { ");
     //ret.append(" color "+ColorNode.toString());
     ret.append(" height "+height.toString()+" ] ");
     ret.append(" color "+ColorNode.toString());

     ret.append(" } \n ");

     ret.append(" } \n ");

     ret.append(" } \n ");

     return ret.toString();

  }// end of produceElevationGrid() 
    
}// end of class VrmlProducer  
